<template>
  <i-wrapper top>
    <i-header :title="$t(`Compatibility`)" :back="{ name: 'compatibility' }" />
    <i-curtain :bottom-circles="false" scrollable fixed>
      <div class="container d-flex flex-column align-items-center">
        <div class="p-your-signs">
          <div class="p-your-sign">
            <img
              v-if="yourSign"
              :src="
                require(`~/assets/images/zodiac-${yourSign.toLowerCase()}-orange${
                  zodiacVariants[yourSign.toLowerCase()] ? `-variant-${zodiacVariants[yourSign.toLowerCase()]}` : ''
                }.png`)
              "
              class="p-your-sign__image" />
            <span v-else class="p-your-sign__placeholder">Your sign</span>
          </div>
          <img src="~assets/images/compatibility-plus-black.svg" class="p-your-sign-plus-image" />
          <div class="p-your-sign">
            <img
              v-if="partnerSign"
              :src="
                require(`~/assets/images/zodiac-${partnerSign.toLowerCase()}-orange${
                  zodiacVariants[partnerSign.toLowerCase()]
                    ? `-variant-${zodiacVariants[partnerSign.toLowerCase()]}`
                    : ''
                }.png`)
              "
              class="p-your-sign__image" />
            <span v-else class="p-your-sign__placeholder">Partner’s sign</span>
          </div>
        </div>
        <div class="p-conclusion">{{ $t(conclusion) }}</div>
        <i-progress-bar :percentage="percentage" :height="15" class="p-progress-bar" />
        <div v-for="sphereRowIndex in 3" :key="sphereRowIndex" class="p-sphere-row">
          <div v-for="sphereCellIndex in 2" :key="sphereCellIndex" class="p-sphere">
            <div class="p-sphere__details">
              <img
                class="p-sphere__image"
                :src="
                  require(`~/assets/images/compatibility-sphere-${
                    sphereCodes[(sphereRowIndex - 1) * 2 + sphereCellIndex - 1]
                  }.svg`)
                " />
              <div class="p-sphere__title">
                {{ $t(`sphereNames.${sphereCodes[(sphereRowIndex - 1) * 2 + sphereCellIndex - 1]}`) }}
              </div>
              <div class="p-sphere__percent">{{ values[(sphereRowIndex - 1) * 2 + sphereCellIndex - 1] }}%</div>
            </div>
            <i-progress-bar :percentage="78" :height="6" class="p-sphere__progress" />
          </div>
        </div>
        <div class="p-report">{{ report }}</div>
      </div>
    </i-curtain>
  </i-wrapper>
</template>

<script>
  export default {
    layout: 'default',
    nuxtI18n: false,
    middleware: ['logged-in-only'],
    transition: { name: 'fade', mode: 'out-in' },

    async asyncData({ $axios, params, redirect, store }) {
      if (!store.state.auth.user.hasActiveSubscription) {
        return redirect({ name: 'compatibility' });
      }

      let match = params.combination.match(/^([a-z]+)-([a-z]+)$/);

      if (!match) {
        return redirect({ name: 'compatibility' });
      }

      let response = await $axios.get(`compatibility/${match[1]}/${match[2]}`);

      return {
        yourSign: response.data.data.sign0,
        partnerSign: response.data.data.sign1,
        conclusion: response.data.data.conclusion,
        report: response.data.data.report,
        percentage: response.data.data.percentage,
        values: response.data.data.values,
      };
    },

    data() {
      return {
        sphereCodes: ['feelings', 'career', 'intimate', 'family', 'friends', 'sport'],

        zodiacVariants: {
          aquarius: 2,
          cancer: 2,
        },
      };
    },
  };
</script>

<style lang="scss" scoped>
  .p-your-signs {
    display: flex;
    align-items: center;
    margin-top: rs(25px);
  }

  .p-your-sign-plus-image {
    width: rs(36px);
    height: rs(36px);
    margin-left: rs(5px);
    margin-right: rs(5px);
  }

  .p-your-sign {
    display: flex;
    align-items: center;
    justify-content: center;
    width: rs(100px);
    height: rs(100px);
  }

  .p-your-sign__image {
    width: rs(100px);
    height: rs(100px);
  }

  .p-conclusion {
    font-size: rf(16px);
    color: #575167;
    font-weight: bold;
    margin-top: rs(10px);
  }

  .p-progress-bar {
    margin-top: rs(20px);
    margin-bottom: rs(23px);
  }

  .p-sphere-row {
    display: flex;
    width: 100%;
    justify-content: space-between;
    margin-top: rs(10px);
  }

  .p-sphere {
    width: 43%;
  }

  .p-sphere__details {
    display: flex;
    align-items: center;
  }

  .p-sphere__image {
    width: rs(20px);
    height: rs(20px);
  }

  .p-sphere__title {
    font-size: rf(14px);
    color: #575167;
    margin-left: rs(10px);
    margin-right: auto;
  }

  .p-sphere__percent {
    font-size: rf(14px);
    color: #575167;
    font-weight: bold;
  }

  .p-sphere__progress {
    margin-top: rs(10px);
  }

  .p-report {
    margin-top: rs(60px);
  }
</style>
